'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x3, _x4, _x5) { var _again = true; _function: while (_again) { var object = _x3, property = _x4, receiver = _x5; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x3 = parent; _x4 = property; _x5 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _reactDomServer = require('react-dom/server');

var HAS_RESOLVED = 'ReactResolver.HAS_RESOLVED';
var IS_CLIENT = 'ReactResolver.IS_CLIENT';

var Resolver = (function (_React$Component) {
  _inherits(Resolver, _React$Component);

  _createClass(Resolver, null, [{
    key: 'childContextTypes',
    value: {
      resolver: _react2['default'].PropTypes.object
    },
    enumerable: true
  }, {
    key: 'contextTypes',
    value: {
      resolver: _react2['default'].PropTypes.object
    },
    enumerable: true
  }, {
    key: 'defaultProps',
    value: {
      props: {},
      resolve: {}
    },
    enumerable: true
  }, {
    key: 'displayName',
    value: 'Resolver',
    enumerable: true
  }, {
    key: 'propTypes',
    value: {
      children: _react2['default'].PropTypes.func.isRequired,
      props: _react2['default'].PropTypes.object,
      resolve: _react2['default'].PropTypes.object
    },
    enumerable: true
  }, {
    key: 'renderClient',
    value: function value(render, node) {
      _reactDom2['default'].render(_react2['default'].createElement(
        Resolver,
        null,
        render
      ), node);
    },
    enumerable: true
  }, {
    key: 'renderServer',
    value: function value(_render) {
      var initialData = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

      var queue = [];

      (0, _reactDomServer.renderToStaticMarkup)(_react2['default'].createElement(
        Resolver,
        { onResolve: function (promise) {
            queue.push(promise);

            return Promise.resolve(true);
          } },
        _render
      ));

      return Promise.all(queue).then(function (results) {
        var formatResults = {};
        results.forEach(function (item) {
          return Object.keys(item).forEach(function (key) {
            formatResults[key] = item[key];
          });
        });

        var data = _extends({}, initialData, formatResults);

        if (Object.keys(initialData).length < Object.keys(data).length) return Resolver.renderServer(_render, data);

        var Resolved = (function (_React$Component2) {
          _inherits(Resolved, _React$Component2);

          function Resolved() {
            _classCallCheck(this, Resolved);

            _get(Object.getPrototypeOf(Resolved.prototype), 'constructor', this).apply(this, arguments);
          }

          _createClass(Resolved, [{
            key: 'render',
            value: function render() {
              return _react2['default'].createElement(
                Resolver,
                null,
                _render
              );
            }
          }], [{
            key: 'displayName',
            value: 'Resolved',
            enumerable: true
          }]);

          return Resolved;
        })(_react2['default'].Component);

        return Resolved;
      });
    },
    enumerable: true
  }]);

  function Resolver(props, context) {
    _classCallCheck(this, Resolver);

    _get(Object.getPrototypeOf(Resolver.prototype), 'constructor', this).call(this, props, context);

    // Internal tracking variables
    this[HAS_RESOLVED] = false;
    this[IS_CLIENT] = false;

    this.state = this.computeState(this.props, {
      pending: {},
      resolved: {}
    });

    if (this.isPending(this.state)) {
      this.resolve(this.state);
      this[HAS_RESOLVED] = false;
    } else {
      this[HAS_RESOLVED] = true;
    }
  }

  _createClass(Resolver, [{
    key: 'cached',
    value: function cached(resolve) {
      var _props = this.props;
      var props = _props.props;
      var cache = _props.cache;

      if (cache || isServer) {
        if (props.hasOwnProperty(resolve)) return props[resolve];else if (this.context.resolver) return this.context.resolver.cached(resolve);
      }

      return null;
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this[IS_CLIENT] = true;
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.unMounted = true;
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var _computeState = this.computeState(nextProps, this.state);

      var pending = _computeState.pending;
      var resolved = _computeState.resolved;

      // Next state will resolve async props again, but update existing sync props
      var nextState = {
        pending: pending,
        resolved: _extends({}, this.state.resolved, resolved)
      };

      this.setAtomicState(nextState);
    }
  }, {
    key: 'computeState',
    value: function computeState(thisProps, nextState) {
      var _this = this;

      var resolve = thisProps.resolve;
      var props = thisProps.props;

      Object.keys(resolve).forEach(function (name) {
        var cached = _this.cached(name);

        if (!nextState.resolved.hasOwnProperty(name) && !nextState.pending.hasOwnProperty(name) && !cached) {
          var factory = resolve[name];
          nextState.pending[name] = factory(props);
        } else if (cached) nextState.resolved[name] = cached;
      });

      return nextState;
    }
  }, {
    key: 'getChildContext',
    value: function getChildContext() {
      return { resolver: this };
    }
  }, {
    key: 'isPending',
    value: function isPending() {
      var state = arguments.length <= 0 || arguments[0] === undefined ? this.state : arguments[0];

      return Object.keys(state.pending).length > 0;
    }
  }, {
    key: 'isParentPending',
    value: function isParentPending() {
      var resolver = this.context.resolver;

      if (resolver) {
        return resolver.isPending() || resolver.isParentPending();
      }

      return false;
    }
  }, {
    key: 'onResolve',
    value: function onResolve(state) {
      if (this.props.onResolve) return this.props.onResolve(state);else if (this.context.resolver) return this.context.resolver.onResolve(state);else return state;
    }
  }, {
    key: 'render',
    value: function render() {
      // Avoid rendering until ready
      if (!this[HAS_RESOLVED]) {
        return false;
      }

      // If render is called again (e.g. hot-reloading), re-resolve
      if (this.isPending(this.state)) {
        this.resolve(this.state);
      }

      // Both those props provided by parent & dynamically resolved
      return this.props.children(_extends({}, this.state.resolved, this.props.props));
    }
  }, {
    key: 'resolve',
    value: function resolve(state) {
      var _this2 = this;

      var pending = Object.keys(state.pending).map(function (name) {
        var promise = state.pending[name];

        return { name: name, promise: promise };
      });

      var promises = pending.map(function (_ref) {
        var promise = _ref.promise;
        return promise;
      });

      var resolving = Promise.all(promises).then(function (values) {
        return values.reduce(function (resolved, value, i) {
          var name = pending[i].name;

          resolved[name] = value;

          return resolved;
        }, {});
      });

      // Resolve listeners get the current resolved
      resolving = this.onResolve(resolving);

      // Update current component (on client)
      resolving.then(function (resolved) {
        _this2[HAS_RESOLVED] = true;

        if (!_this2[IS_CLIENT]) {
          return false;
        }

        var nextState = {
          pending: {},
          resolved: _extends({}, state.resolved, resolved)
        };

        _this2.setAtomicState(nextState);
      });
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      // Prevent updating when parent is changing values
      if (this.isParentPending()) {
        return false;
      }

      // Prevent rendering until pending values are resolved
      if (this.isPending(nextState)) {
        this.resolve(nextState);

        return false;
      }

      // Update if we have resolved successfully
      return this[HAS_RESOLVED];
    }
  }, {
    key: 'setAtomicState',
    value: function setAtomicState(nextState) {
      if (this.unMounted) {
        return;
      }

      this.setState(nextState);
    }
  }]);

  return Resolver;
})(_react2['default'].Component);

exports['default'] = Resolver;
module.exports = exports['default'];